module.exports = (config) ->
	log    = require './../helpers/log'
	isType = require './../helpers/isType'
	test   = require('./../helpers/test')()

	# defaults
	# ========
	lang =
		coffee: '/**/*.coffee'
		css:    '/**/*.css'
		es6:    '/**/*.es6'
		html:   '/**/*.html'
		images: '/**/*.*(gif|jpg|jpeg|png)'
		js:     '/**/*.js'
		less:   '/**/*.less'
		sass:   '/**/*.sass'

	# helpers
	# =======
	initGlob = ->
		['dist', 'src'].forEach (loc) ->
			glob[loc] = {}
			['rb', 'app'].forEach (v1) ->
				glob[loc][v1] = {}
				['client', 'server'].forEach (v2) ->
					glob[loc][v1][v2] = {}

	addGlob = (loc, type, langs) ->
		for own k1, v1 of glob[loc]
			for own k2, v2 of v1
				continue if k2 is 'server' and type isnt 'scripts'
				v2[type] = {} if not isType.object v2[type]
				langs.forEach (v3) ->
					v2[type][v3] = config[loc][k1][k2][type].dir + lang[v3]

	# init glob
	# =========
	glob = {}
	initGlob()

	# src
	# ===
	# addGlob 'src', 'images',  ['images']
	# addGlob 'src', 'scripts', ['js']
	addGlob 'src', 'scripts', ['coffee']
	# addGlob 'src', 'scripts', ['es6']
	# addGlob 'src', 'styles',  ['css']
	addGlob 'src', 'styles',  ['less']
	# addGlob 'src', 'styles',  ['sass']
	addGlob 'src', 'views',   ['html']

	# dist
	# ====
	# addGlob 'dist', 'images',  ['images']
	addGlob 'dist', 'scripts', ['js']
	addGlob 'dist', 'styles',  ['css']
	addGlob 'dist', 'views',   ['html']

	# add glob to config
	# ==================
	config.glob = glob

	# logs
	# ====
	# log.json glob, 'glob ='
	# log.json config, 'config ='

	# tests
	# =====
	test.log 'true', config.glob, 'you forgot to add glob to config'

	# return
	# ======
	config


