module.exports = (config) ->
	log  = require './../helpers/log'
	test = require('./../helpers/test')()

	# init node_modules
	# =================
	node_modules =
		dist:
			dir: "#{config.dist.rb.server.scripts.dir}/node_modules"
			modules: {}
		src:
			dir: "#{config.module.dir}/node_modules"
			modules: {}

	# helpers
	# =======
	addModule = (module) ->
		for own k, v of node_modules
			v.modules[module] = "#{v.dir}/#{module}"

	# modules
	# =======
	addModule 'express'

	# add node_modules to config
	# ==========================
	config.node_modules = node_modules

	# logs
	# ====
	# log.json node_modules, 'node_modules ='
	# log.json config, 'config ='

	# tests
	# =====
	test.log 'true', config.node_modules,
		'you forgot to add node_modules to config'

	# return
	# ======
	config