module.exports = (options={}) ->
	gulp = require 'gulp'
	require('./init/init-rb')()
	# config      = require('./config/config.coffee') gulp, dist:client:scripts:dir:'xxx'
	# config      = require('./config/config.coffee') gulp, dist:server:dir:'xxx'
	# config      = require('./config/config.coffee') gulp, dist:dir:'xxx'
	# config      = require('./config/config.coffee') gulp, src:dir:'yyy'
	# config      = require('./config/config.coffee') gulp, dist:client:spa:file:'index.html'
	# config      = require('./config/config.coffee') gulp, ports:server:5000,reload:5001
	# config      = require('./config/config.coffee') gulp, dist:server:file:'app'
	# config      = require('./config/config.coffee') gulp, src:client:libs:dir:'bower'
	config      = require('./config/config.coffee') gulp, options
	runSequence = require 'run-sequence'

	# Available Tasks - Prefixed with #{config.prefix.tasks}
	require('./tasks/bower')                    gulp, config # bower
	require('./tasks/clean-dist')               gulp, config # clean-dist
	require('./tasks/clean-config')             gulp, config # clean-config
	require('./tasks/build-config')             gulp, config # build-config
	require('./tasks/copy-libs')                gulp, config # copy-libs
	require('./tasks/copy-html')                gulp, config # main-bower-files
	require('./tasks/coffee')                   gulp, config # coffee
	require('./tasks/less')                     gulp, config # less
	require('./tasks/build-spa')                gulp, config # build-spa
	require('./tasks/server/copy-config')       gulp, config # server-copy-config
	require('./tasks/server/copy-nm-express')   gulp, config # server-copy-nm-express
	require('./tasks/watch')                    gulp, config # watch
	bs = require('./tasks/server/browser-sync') gulp, config # browser-sync
	require('./tasks/server/nodemon')           gulp, config, bs # server-nodemon

	gulp.task "#{config.prefix.tasks}server", [
		"#{config.prefix.tasks}server-nodemon"
		"#{config.prefix.tasks}browser-sync"
	]

	gulp.task config.module.task, (cb) ->
		runSequence(
			"#{config.prefix.tasks}bower"
			"#{config.prefix.tasks}clean-dist"
			"#{config.prefix.tasks}clean-config"
			"#{config.prefix.tasks}build-config"
			"#{config.prefix.tasks}copy-libs"
			"#{config.prefix.tasks}copy-html"
			"#{config.prefix.tasks}coffee"
			"#{config.prefix.tasks}less"
			"#{config.prefix.tasks}build-spa"
			"#{config.prefix.tasks}server-copy-config"
			"#{config.prefix.tasks}server-copy-nm-express"
			"#{config.prefix.tasks}server"
			"#{config.prefix.tasks}watch"
			cb
		)

	return if not config.isDev
	gulp.task 'default', ->
		runSequence config.module.task

