module.exports = (gulp, config) ->
	q        = require 'q'
	gs       = require 'glob-stream'
	template = require 'gulp-template'
	data     = styles:[], scripts:[]

	# task
	# ====
	runTask = (src, dest, data) ->
		defer = q.defer()
		gulp.src src
			.pipe template data
			.pipe gulp.dest dest
			.on 'end', ->
				# console.log 'SPA Built'.yellow
				clearData() # todo, optimize this
				defer.resolve()
		defer.promise

	# globs
	# =====
	getGlob = (loc, type, lang) ->
		config.glob.dist[loc].client[type][lang]

	globs =
		css:
			rb:  getGlob 'rb',  'styles', 'css'
			app: getGlob 'app', 'styles', 'css'
		js:
			rb:  getGlob 'rb',  'scripts', 'js'
			app: getGlob 'app', 'scripts', 'js'

	# helpers
	# =======
	processFiles = (loc, files) -> # loc = rb | app
		files.forEach (v, i) ->
			files[i] = files[i].replace(
				"#{config.app.dir}/#{config.dist[loc].client.dir}/", '')
			if loc isnt 'app'
				files[i] = "#{config.prefix.distDir}/#{files[i]}"
		files

	addData = (type, loc, files) ->
		files = processFiles loc, files
		files.forEach (v, i) ->
			data[type].push v

	clearData = -> # needed for watch events: add and unlink
		libs = 'rapid-build/libs'
		data.styles  = []
		data.scripts = [
			"#{libs}/angular.js"
			"#{libs}/angular-route.js"
			"#{libs}/angular-sanitize.js"
		]
	clearData() # fix this shit

	getFiles = (type, loc, glob) -> # loc = rb | app
		files = []
		defer = q.defer()
		gs.create(glob).on 'data', (file) ->
			files.push file.path
		.on 'end', ->
			addData type, loc, files
			defer.resolve()
		defer.promise

	getAllFiles = (type, lang) -> # sync
		tasks = []
		defer = q.defer()
		locs  = Object.keys globs[lang]

		locs.forEach (loc) ->
			tasks.push ->
				getFiles type, loc, globs[lang][loc]

		tasks.reduce(q.when, q()).done -> defer.resolve()
		defer.promise

	buildData = -> # async
		q.all [
			getAllFiles 'styles', 'css'
			getAllFiles 'scripts', 'js'
		]

	# register task
	# =============
	gulp.task "#{config.prefix.tasks}build-spa", ->
		defer = q.defer()
		buildData().done ->
			# console.log data
			runTask(
				config.src.rb.client.spa.path
				config.dist.app.client.dir
				data
			).done -> defer.resolve()
		defer.promise





